package com.logicbig.example;

import javax.swing.table.AbstractTableModel;
import java.math.BigDecimal;
import java.util.*;

public class ForexTableModel extends AbstractTableModel {
    private Map<String, BigDecimal> forexRates = new TreeMap<>();
    private String[] columnNames = {"Currency Pair", "Rate"};

    public void updateRateWithoutFiringEvent(String currency, BigDecimal rate) {
        forexRates.put(currency, rate);
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getRowCount() {
        return forexRates.size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
       if (columnIndex == 0) {
            String currency = getCurrencyByRow(rowIndex);
            return currency;
        } else if (columnIndex == 1) {
            String currency = getCurrencyByRow(rowIndex);
            return forexRates.get(currency);
        }
        return null;
    }

    private String getCurrencyByRow(int rowIndex) {
        return forexRates.keySet()
                         .toArray(new String[forexRates.size()])[rowIndex];
    }
}