package com.logicbig.example;


import com.logicbig.uicommon.Throttler;
import javax.swing.*;
import java.awt.*;
import java.math.BigDecimal;
import java.util.function.BiConsumer;

public class ThrottlingExampleMain {
    public static void main(String[] args) {
        ForexTableModel tableModel = new ForexTableModel();
        JTable table = new JTable(tableModel);
        listenToForexChanges(tableModel);
        JFrame frame = createFrame();
        frame.add(new JScrollPane(table));
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }

    private static void listenToForexChanges(ForexTableModel tableModel) {
        Throttler throttler = new Throttler(1000, new Runnable() {
            @Override
            public void run() {
                //it is in EDT
                tableModel.fireTableDataChanged();
            }
        });

        TestDataService.Instance.listenToDataUpdate(
                (pair, rate) -> SwingUtilities.invokeLater(() -> {
                    //table model must be accessed in EDT for thread safety
                    tableModel.updateRateWithoutFiringEvent(pair, rate);
                    throttler.updateReceived();
                }));
    }

    private static JFrame createFrame() {
        JFrame frame = new JFrame("Throttling Example");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(new Dimension(500, 300));
        return frame;
    }
}